<template>
    <div class="app-container">
        <el-row :gutter="20" type="flex" justify="center" align="middle">
            <el-col :lg="23" :md="23" :sm="24" align="middle" class="paper">
                <div class="filter-container">
                    <el-row :gutter="20">
                        <el-col :span="2" class="text-align-left">
                            <h3>Users</h3>
                        </el-col>
                        <el-col :span="22">
                            <el-row :gutter="10">
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-input 
                                        prop="keyword" 
                                        v-model="filter.keyword" 
                                        ref="keyword" 
                                        name="keyword" 
                                        placeholder="Full name, badge, phone" 
                                        size="large" 
                                        class="filter-item width-100" 
                                        clearable 
                                        @keyup.enter.native="getUsers(1, false)" 
                                        @clear="getUsers(1, false)"/>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-select
                                        ref="organization"
                                        name="organization"
                                        class="width-100"
                                        clearable
                                        filterable
                                        remote
                                        :remote-method="getFilterOrganizations"
                                        v-model="filter.organization"
                                        value-key="id"
                                        placeholder="Type organization name or code"
                                        no-data-text="No Record Found"
                                        :loading="organizationLoading"
                                        @clear="handleClearOrganization('filter')">
                                        <el-option
                                            v-for="item in filterOrganizations"
                                            :key="item.id"
                                            :label="item.name.capitalize()"
                                            :value="item.id">     
                                            <span style="float: left">{{ item.name.capitalize() }}</span>
                                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.code }}</strong>                   
                                        </el-option>
                                    </el-select>
                                </el-col>
                                <el-col :lg="4" :md="4" :sm="24">
                                    <el-select
                                        ref="role"
                                        name="role"
                                        class="width-100"
                                        v-model="filter.role"
                                        value-key="id"
                                        placeholder="Select role"
                                        no-data-text="No Data"
                                        clearable
                                        @clear="handleClearFilterRole()">
                                        <el-option
                                            v-for="item in roles"
                                            :key="item.id"
                                            :label="item.name"
                                            :value="item.id">                        
                                        </el-option>
                                    </el-select>
                                </el-col>
                                <el-col :lg="4" :md="4" :sm="24">
                                    <el-select
                                        ref="status"
                                        name="status"
                                        class="width-100"
                                        v-model="filter.status"
                                        value-key="id"
                                        placeholder="Select status"
                                        no-data-text="No Data"
                                        clearable
                                        @clear="handleClearFilterStatus()">
                                        <el-option
                                            v-for="item in statuses"
                                            :key="item.key"
                                            :label="item.value"
                                            :value="item.key">                        
                                        </el-option>
                                    </el-select>
                                </el-col>
                                <el-col :lg="3" :md="3" :sm="24">
                                    <el-button @click="getUsers(1, false)" size="small" type="primary" class="filter-item width-100" style="font-size:14px;">
                                        <i class="ion-ios-search"></i> Search
                                    </el-button>
                                </el-col>
                                <el-col :lg="3" :md="3" :sm="24">
                                    <el-button size="small" type="success" class="filter-item width-100" style="font-size:14px;" @click="handleAddNew">
                                        <i class="ion-ios-add-circle"></i> Add
                                    </el-button>
                                </el-col>
                            </el-row>
                        </el-col>
                    </el-row>
                </div>
                <el-table v-loading="tableLoading" :data="users" style="width: 100%" :height="tableHeight()" fit highlight-current-row v-infinite-scroll="loadMore">
                    <el-table-column
                        fixed="left"
                        label="Name"
                        width="200">
                        <template slot-scope="scope">
                            <span style="color:#3E89FA;">{{ scope.row.fullname.capitalize() }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Organization"
                        width="250">
                        <template slot-scope="scope">
                            <span>{{ scope.row.organization != null ? convertAmpersand(scope.row.organization.name).capitalize() : '-' }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Badge"
                        width="125">
                        <template slot-scope="scope">
                            <span>{{ scope.row.badge }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Phone"
                        width="125">
                        <template slot-scope="scope">
                            <span>{{ scope.row.phone }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        align="center"
                        label="Status"
                        width="150">
                        <template slot-scope="scope">
                            <span v-if="scope.row.status == 'verified'"><el-tag type="success">Verified</el-tag></span>
                            <span v-else-if="scope.row.status == 'unverified'"><el-tag type="warning">Unverified</el-tag></span>
                            <span v-else><el-tag type="danger">Banned</el-tag></span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Role"
                        width="150">
                        <template slot-scope="scope">
                            <span><el-tag type="info">{{ scope.row.role.name }}</el-tag></span>
                        </template>
                    </el-table-column>                    
                    <el-table-column
                        label="Last Updated"
                        width="150">
                        <template slot-scope="scope">
                            {{ dateFormat(scope.row.updated) }}
                        </template>
                    </el-table-column>
                    <el-table-column
                        fixed="right"
                        label="Action"
                        min-width="200">
                        <template slot-scope="{row}">
                            <el-button v-permission="[row, 'user', 'viewother']" type="text" @click="handleEdit(row)">Edit</el-button>
                            <el-button v-permission="[row, 'user', 'deleteother']" type="text" class="text-danger" @click="handleDelete(row)">Delete</el-button>
                        </template>
                    </el-table-column>
                </el-table>

                <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
                    <el-form ref="userForm" :model="userForm" :rules="userRules">
                        <aside>
                            <el-alert type="info" description="Add or edit user" :closable=false show-icon></el-alert>
                        </aside>
                        <el-row :gutter="20">
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Full Name" prop="fullname">
                                    <el-input ref="fullname" name="fullname" v-model="userForm.fullname" placeholder="Full name" autocomplete="off" maxlength="45" class="has-suffix" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Phone" prop="phone">
                                    <el-input ref="phone" name="phone" v-model="userForm.phone" placeholder="Mobile phone number" autocomplete="off" maxlength="25" class="has-suffix" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                        </el-row>   
                        <el-row :gutter="20">
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Badge" prop="badge">
                                    <el-input ref="badge" name="badge" v-model="userForm.badge" placeholder="Company badge number" autocomplete="off" maxlength="25" class="has-suffix" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Organization" prop="organization">
                                    <el-select
                                        ref="organization"
                                        name="organization"
                                        class="width-100"
                                        clearable
                                        filterable
                                        remote
                                        :remote-method="getOrganizations"
                                        v-model="userForm.organization"
                                        value-key="id"
                                        placeholder="Type organization name or code"
                                        no-data-text="No Record Found"
                                        :loading="organizationLoading"
                                        @clear="handleClearOrganization('content')">
                                        <el-option
                                            v-for="item in organizations"
                                            :key="item.id"
                                            :label="item.name.capitalize()"
                                            :value="item.id">     
                                            <span style="float: left">{{ item.name.capitalize() }}</span>
                                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.code }}</strong>                   
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>
                        </el-row>  
                        <el-row :gutter="20">
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Role" prop="role">
                                    <el-select
                                        ref="role"
                                        name="role"
                                        class="width-100"
                                        v-model="userForm.role"
                                        value-key="id"
                                        placeholder="Select role"
                                        no-data-text="No Data">
                                        <el-option
                                            v-for="item in roles"
                                            :key="item.id"
                                            :label="item.name"
                                            :value="item.id">                        
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Status" prop="status">
                                    <el-select v-model="userForm.status" placeholder="Select status" class="width-100" ref="status" name="status">
                                        <el-option
                                            v-for="item in statuses"
                                            :key="item.value"
                                            :label="item.value"
                                            :value="item.key">
                                        </el-option>
                                    </el-select>
                                </el-form-item>
                            </el-col>
                        </el-row>                                     
                    </el-form>
                    <span slot="footer" class="dialog-footer">
                        <el-button @click="showDialog = false" size="medium"><i class="ion-ios-close-circle-outline"></i> Cancel</el-button>
                        <el-button v-permission="[null, 'user', 'editother']" @click="handleSubmit" size="medium" type="success">
                            <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                        </el-button>
                    </span>
                </el-dialog>
            </el-col>
        </el-row>
    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import { parseError, dateFormat, tableHeight, convertAmpersand } from '../../utils/index';
export default {
    name: 'Users',
    directives: {
        permission
    },
    data(){
        return{
            tableLoading: false,
            dialogLoading: false,
            organizationLoading: false,
            showDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Edit User',
                add: 'Add New User'
            },
            filter: {
                keyword: '',
                organization: null,
                role: null,
                status: ''
            },
            statuses: [{
                key: 'unverified',
                value: 'Unverified'
            }, {
                key: 'verified',
                value: 'Verified'
            }, {
                key: 'banned',
                value: 'Banned'
            }],
            userForm: {
                id: null,
                fullname: '',
                badge: '',
                phone: '',
                organization: null,
                role: null,
                status: 'unverified'
            },
            userRules: {
                fullname: [{ 
                    required: true, message: 'Full name is required', trigger: 'blur'
                }, {
                    max: 255, message: 'Full name length 255 characters maximum', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z\s]{1,255})$/, 
                    message: 'Only letters and spaces are allowed.', 
                    trigger: 'blur'
                }],
                phone: [{
                    required: true, message: 'Phone number is required', trigger: 'blur'
                },{
                    max: 25, message: 'Phone number maximum 25 characters', trigger: 'blur'
                }, {
                    pattern: /\(?(?:\+628|628|08)(?:\d{2,3})?\)?[ .-]?\d{2,4}[ .-]?\d{2,4}[ .-]?\d{2,4}/, 
                    message: 'Invalid phone number', 
                    trigger: 'blur'
                }],
                badge: [{
                    max: 25, message: 'Company badge number maximum 25 characters', trigger: 'blur'
                }],
                status: [{
                    required: true, message: 'User status is required', trigger: 'change'
                }],
                role: [{
                    required: true, message: 'Role is required', trigger: 'change'
                }],
            },
        }
    },
    computed:{
        ...mapGetters('user', ['me']),
        ...mapGetters('role', ['roles']),
        ...mapGetters('organization', [
            'organizations',
            'filterOrganizations'
        ]),
        ...mapGetters('user', [
            'users',
            'pagination'
        ])
    },
    created(){
        const self = this;
        self.getRoles();
        self.getUsers(1, false);
    },
    methods: {
        dateFormat,
        tableHeight,
        convertAmpersand,
        getFilterOrganizations(q){
            const self = this;

            if(q.length >= 3){
                self.organizationLoading = true;
                self.$store.dispatch('organization/getOrganizations', {
                    q: q,
                    page: 1,
                    perpage: 25,
                    exclude: 'statuses',
                    type: 'filter'
                }).then(() => {
                    self.organizationLoading = false;
                });
            }
        },
        getOrganizations(q){
            const self = this;

            if(q.length >= 3){
                self.organizationLoading = true;
                self.$store.dispatch('organization/getOrganizations', {
                    q: q,
                    page: 1,
                    perpage: 25,
                    exclude: 'statuses',
                    type: 'content'
                }).then(() => {
                    self.organizationLoading = false;
                });
            }
        },
        getRoles() {
            const self = this;

            self.$store.dispatch('role/getAllRoles', {
                page: 1,
                perpage: 50,
            });

        },
        getUsers(page, loadmore){
            const self = this;

            self.tableLoading = true;

            let params = {
                page: page,
                perpage: 25,
                loadmore: loadmore,
                only: 'id,fullname,badge,phone,status,created,updated,organization.id,organization.name,role.id,role.name'
            };

            if(self.filter.keyword.trim().length > 0){
                params.q = self.filter.keyword;
            }

            if(self.filter.role != null){
                params.role = self.filter.role;
            }

            if(self.filter.organization != null){
                params.organization = self.filter.organization;
            }

            if(self.filter.status.trim().length > 0){
                params.status = self.filter.status;
            }

            self.$store.dispatch('user/getUsers', params).then(()=>{
                self.tableLoading = false;
            });
        },
        loadMore(){
            const self = this;
            
            if(self.pagination.has_next){    
                self.getUsers(self.pagination.page + 1, true);
            }
        },
        handleAddNew(){
            const self = this;
            self.dialogStatus = 'add';
            self.showDialog = true;          
            self.$nextTick(() => {
                self.$refs['userForm'].clearValidate();
            });
        },
        handleEdit(user){
            const self = this;
            self.dialogStatus = 'edit';
            self.showDialog = true;

            self.userForm.id = user.id;
            self.userForm.fullname = user.fullname;
            self.userForm.badge = user.badge;
            self.userForm.phone = user.phone;
            self.userForm.organization = user.organization != null ? user.organization.id : null;
            self.userForm.role = user.role.id;
            self.userForm.status = user.status;

            if(user.organization != null){
                self.getOrganizations(user.organization.name);
            }

            self.$nextTick(() => {
                this.$refs['userForm'].clearValidate();
            });
        },
        handleDelete(user){
            const self = this;

            self.$confirm('You are about to delete this user. This operation cannot be undone. Are you sure?', 'Warning', {
                confirmButtonText: 'Yes, I\'m Sure',
                cancelButtonText: 'Cancel'
            }).then(()=>{
                self.tableLoading = true;
                self.$store.dispatch('user/deleteUser', {
                    id: user.id
                }).then((response) => {
                    self.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        self.$message.error({
                            message: error.messages
                        });
                    }else{
                        self.$message.success({
                            message: response.message
                        });
                    }
                });
            });
        },
        handleSubmit(){
            const self = this;

            self.$refs.userForm.validate((valid)=>{
                if(valid){
                    self.dialogLoading = true;

                    let action = 'user/addUser';
                    let params = {
                        fullname: self.userForm.fullname,
                        badge: self.userForm.badge,
                        phone: self.userForm.phone,
                        organization: self.userForm.organization,
                        role: self.userForm.role,
                        status: self.userForm.status
                    };

                    if(self.dialogStatus == 'edit'){
                        action = 'user/editUser';
                        params.id = self.userForm.id;
                    }

                    self.$store.dispatch(action, params).then((response)=>{
                        self.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            self.$message.error({
                                message: error.messages
                            });
                        }else{
                            self.showDialog = false;
                            self.$message.success({
                                message: response.message
                            });

                            self.resetForm();
                        }
                    });
                }else{
                    return false;
                }
            });
        },
        resetForm() {
            const self = this;

            self.userForm = {
                id: null,
                fullname: '',
                badge: '',
                phone: '',
                organization: null,
                role: null,
                status: 'unverified'
            };

            self.handleClearOrganization();
        },
        handleClearOrganization(type){
            const self = this;
            self.filter.organization = null;
            self.$store.dispatch('organization/resetOrganizations', {
                type: type
            });
        },
        handleClearFilterRole(){
            const self = this;
            self.filter.role = null;
        },
        handleClearFilterStatus(){
            const self = this;
            self.filter.status = '';
        }
    }
}
</script>